using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using Excel = Microsoft.Office.Interop.Excel;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace ADX_Task_Pane_Color_CS
{
	/// <summary>
	///   Add-in Express Add-in Module
	/// </summary>
	[GuidAttribute("C145F2ED-ECD2-4513-8BD2-01E05888D47C"), ProgId("ADX_Task_Pane_Color_CS.AddinModule")]
	public class AddinModule : AddinExpress.MSO.ADXAddinModule
	{
		public AddinModule()
		{
			InitializeComponent();
			// Please add any initialization code to the AddinInitialize event handler
		}

		private AddinExpress.XL.ADXExcelTaskPanesManager adxExcelTaskPanesManager1;
		private AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
		private AddinExpress.XL.ADXExcelTaskPanesCollectionItem ExcelTaskPanesCollectionItem;
		private AddinExpress.OL.ADXOlFormsCollectionItem OlFormsCollectionItem;

		#region Component Designer generated code
		/// <summary>
		/// Required by designer
		/// </summary>
		private System.ComponentModel.IContainer components;

		/// <summary>
		/// Required by designer support - do not modify
		/// the following method
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.adxExcelTaskPanesManager1 = new AddinExpress.XL.ADXExcelTaskPanesManager(this.components);
			this.ExcelTaskPanesCollectionItem = new AddinExpress.XL.ADXExcelTaskPanesCollectionItem(this.components);
			this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
			this.OlFormsCollectionItem = new AddinExpress.OL.ADXOlFormsCollectionItem(this.components);
			// 
			// adxExcelTaskPanesManager1
			// 
			this.adxExcelTaskPanesManager1.Items.Add(this.ExcelTaskPanesCollectionItem);
			this.adxExcelTaskPanesManager1.SetOwner(this);
			// 
			// ExcelTaskPanesCollectionItem
			// 
			this.ExcelTaskPanesCollectionItem.Position = AddinExpress.XL.ADXExcelTaskPanePosition.Right;
			this.ExcelTaskPanesCollectionItem.TaskPaneClassName = "ADX_Task_Pane_Color_CS.ADXExcelTaskPane1";
			// 
			// adxOlFormsManager1
			// 
			this.adxOlFormsManager1.Items.Add(this.OlFormsCollectionItem);
			this.adxOlFormsManager1.SetOwner(this);
			// 
			// OlFormsCollectionItem
			// 
			this.OlFormsCollectionItem.ExplorerItemTypes = ((AddinExpress.OL.ADXOlExplorerItemTypes)((((((((AddinExpress.OL.ADXOlExplorerItemTypes.olMailItem | AddinExpress.OL.ADXOlExplorerItemTypes.olAppointmentItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olContactItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olTaskItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olJournalItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olNoteItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olPostItem)
						| AddinExpress.OL.ADXOlExplorerItemTypes.olDistributionListItem)));
			this.OlFormsCollectionItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.RightSubpane;
			this.OlFormsCollectionItem.FormClassName = "ADX_Task_Pane_Color_CS.ADXOlForm1";
			// 
			// AddinModule
			// 
			this.AddinName = "ADX_Task_Pane_Color_CS";
			this.SupportedApps = ((AddinExpress.MSO.ADXOfficeHostApp)((AddinExpress.MSO.ADXOfficeHostApp.ohaExcel | AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook)));
			this.OfficeColorSchemeChanged += new AddinExpress.MSO.OfficeColorSchemeChanged_EventHandler(this.AddinModule_OfficeColorSchemeChanged);

		}
		#endregion

		#region Add-in Express automatic code

		// Required by Add-in Express - do not modify
		// the methods within this region

		public override System.ComponentModel.IContainer GetContainer()
		{
			if (components == null)
				components = new System.ComponentModel.Container();
			return components;
		}

		[ComRegisterFunctionAttribute]
		public static void AddinRegister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
		}

		[ComUnregisterFunctionAttribute]
		public static void AddinUnregister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
		}

		public override void UninstallControls()
		{
			base.UninstallControls();
		}

		#endregion

		public Excel._Application ExcelApp
		{
			get
			{
				return (HostApplication as Excel._Application);
			}
		}

		public Outlook._Application OutlookApp
		{
			get
			{
				return (HostApplication as Outlook._Application);
			}
		}

		private void AddinModule_OfficeColorSchemeChanged(object sender, AddinExpress.MSO.OfficeColorScheme theme)
		{
			switch (this.HostType)
			{
				case AddinExpress.MSO.ADXOfficeHostApp.ohaExcel:
					(ExcelTaskPanesCollectionItem.TaskPaneInstance as ADXExcelTaskPane1).DoPaint(theme);
					break;
				case AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook:
					for (int i = 0; i < OlFormsCollectionItem.FormInstanceCount; i++)
						(OlFormsCollectionItem.FormInstances(i) as ADXOlForm1).DoPaint(theme);
					break;
			}
		}
	}
}

